import java.net.Socket;
import java.util.regex.*;
import mpl.MPLSet;
import mpl.MPLShutdown;
import mpl.MPLSimpleShutdown;

// this aspect includes policies: 
// - allowed_hosts_policy
public aspect allowed_hosts_policy {
   private String[] allowedHosts$mplSetDummy = {
      "localhost", "127.0.0.1"};
   private MPLSet<String> allowedHosts =
      new MPLSet<String>(allowedHosts$mplSetDummy);
   private Pattern allowedPatterns = Pattern.compile(
      "internal.*company");

   // shutdown sequence
   private MPLShutdown mplExit =
      new MPLSimpleShutdown();

// START RULE NO. 1
   pointcut rule1(String url):
      args(url) &&
      call(static Remote Naming.lookup(String));

   before(String url):
      rule1(url)
   {
      try {
      if (!( url.split("/").length>2&&
        (allowedHosts.contains(url.split("/")[2])||
        allowedPatterns.matcher(url.split("/")[2]).
        matches()) ))
      { mplExit.shutdown(); }
      } catch (Exception e) {
         System.err.println(
           "Error: Policy caused an exception" +
           ")- execution halted");
         mplExit.shutdown();
      }
   }
// START RULE NO. 2
   pointcut rule2(String url, int port):
      args(url, port) &&
      call(Socket.new(String, int));

   before(String url, int port):
      rule2(url, port)
   {
      try {
      if (!( allowedHosts.contains(url)||
        allowedPatterns.matcher(url).matches() ))
      { mplExit.shutdown(); }
      } catch (Exception e) {
         System.err.println(
           "Error: Policy caused an exception" +
           ")- execution halted");
         mplExit.shutdown();
      }
   }
}
