import java.io.File;
import mpl.MPLShutdown;
import mpl.MPLSimpleShutdown;

// this aspect includes policies: 
// - directory_policy
public aspect directory_policy {

   // shutdown sequence
   private MPLShutdown mplExit =
      new MPLSimpleShutdown();

// START RULE NO. 1
   pointcut rule1(File mplTarget):
      target(mplTarget) &&
      call(File[] listFiles(..));

   before(File mplTarget):
      rule1(mplTarget)
   {
      try {
      if (!( mplTarget.getCanonicalPath().equals(System
        .getProperty("user.dir")) ))
      { mplExit.shutdown(); }
      } catch (Exception e) {
         System.err.println(
           "Error: Policy caused an exception" +
           " - execution halted");
         mplExit.shutdown();
      }
   }

// START RULE NO. 2
   pointcut rule2(File mplTarget):
      target(mplTarget) &&
      call(String[] list(..));

   before(File mplTarget):
      rule2(mplTarget)
   {
      try {
      if (!( mplTarget.getCanonicalPath().equals(System
        .getProperty("user.dir")) ))
      { mplExit.shutdown(); }
      } catch (Exception e) {
         System.err.println(
           "Error: Policy caused an exception" +
           " - execution halted");
         mplExit.shutdown();
      }
   }

// START RULE NO. 3
   pointcut rule3(String key, String value):
      args(key, value) &&
      call(static String setProperty(String, String));

   before(String key, String value):
      rule3(key, value)
   {
      try {
      if (!( key.equals("user.dir")&&
        value.equals(System.getProperty("user.dir")) ))
      { mplExit.shutdown(); }
      } catch (Exception e) {
         System.err.println(
           "Error: Policy caused an exception" +
           " - execution halted");
         mplExit.shutdown();
      }
   }
}