import mpl.MPLShutdown;
import mpl.MPLSimpleShutdown;

// this aspect includes policies: 
// - fun_sequence_policy1
public aspect fun_sequence_policy1 {
   private String currentFun;
   private String previousFun = null;

   // shutdown sequence
   private MPLShutdown mplExit =
      new MPLSimpleShutdown();

// START RULE NO. 1
   pointcut rule1():
      call(static void funA());

   before():
      rule1()
   {
   try {
      previousFun = currentFun;
      currentFun = "A";
   } catch (Exception e) {
      System.err.println(
        "Error: Policy caused an exception" +
        " - execution halted");
      mplExit.shutdown();
   }
      try {
      if (!( true ))
      { mplExit.shutdown(); }
      } catch (Exception e) {
         System.err.println(
           "Error: Policy caused an exception" +
           " - execution halted");
         mplExit.shutdown();
      }
   }

// START RULE NO. 2
   pointcut rule2():
      call(static void funB());

   before():
      rule2()
   {
   try {
      previousFun = currentFun;
      currentFun = null;
   } catch (Exception e) {
      System.err.println(
        "Error: Policy caused an exception" +
        " - execution halted");
      mplExit.shutdown();
   }
      try {
      if (!( previousFun.equals("A") ))
      { mplExit.shutdown(); }
      } catch (Exception e) {
         System.err.println(
           "Error: Policy caused an exception" +
           " - execution halted");
         mplExit.shutdown();
      }
   }

// START RULE NO. 3
   pointcut rule3():
      call(static void funX());

   before():
      rule3()
   {
   try {
      previousFun = currentFun;
      currentFun = null;
   } catch (Exception e) {
      System.err.println(
        "Error: Policy caused an exception" +
        " - execution halted");
      mplExit.shutdown();
   }
      try {
      if (!( true ))
      { mplExit.shutdown(); }
      } catch (Exception e) {
         System.err.println(
           "Error: Policy caused an exception" +
           " - execution halted");
         mplExit.shutdown();
      }
   }
}