name message_policy

class java.net.Socket,
      java.io.OutputStream,
      java.io.ObjectOutputStream;

var
  allowedMsgCount: Integer[] = [ 5, 6, 7 ];
  allowedMsgCharCount: int = 250;
  msgCounters: Integer[] = [ 0, 0, 0 ];
  msgCharCounter: int = 0;    

  lowerCharLimit: int = 10;
  upperCharLimit: int = 30;
    
  len: int; // temporary
    
  sockets: set of Socket;
  oStreams: set of OutputStream;
  ooStreams: set of ObjectOutputStream;
rules

Socket: Socket new(..)
cond
  none
effects
  sockets = sockets + mplReturn;
  oStreams = oStreams + mplReturn.getOutputStream();

Socket: OutputStream getOutputStream()
cond
  sockets.contains(mplTarget)
effects
  oStreams = oStreams + mplReturn;
  
ObjectOutputStream:
  ObjectOutputStream new(OutputStream os)
cond
  oStreams.contains(os)
effects
  ooStreams = ooStreams + mplReturn;
  
ObjectOutputStream: void writeObject(Object msg)
cond
  msgCounters[0] <= allowedMsgCount[0] &&
  msgCounters[1] <= allowedMsgCount[1] &&
  msgCounters[2] <= allowedMsgCount[2] &&
  msgCharCounter <= allowedMsgCharCount
pre effects
  len = ((String)msg).length();
  
  if (len < lowerCharLimit)
    msgCounters[0] = msgCounters[0] + 1;    
  if (len >= lowerCharLimit &&
      len <= upperCharLimit)
    msgCounters[1] = msgCounters[1] + 1;
  if (len > upperCharLimit)
    msgCounters[2] = msgCounters[2] + 1;
    
  msgCharCounter = msgCharCounter + len;
  
