import java.net.Socket;
import java.rmi.Naming;
import java.rmi.Remote;
import mpl.MPLShutdown;
import mpl.MPLSimpleShutdown;

// this aspect includes policies: 
// - socket_conn_policy
public aspect socket_conn_policy {
   private String lastRMIHost;

   // shutdown sequence
   private MPLShutdown mplExit =
      new MPLSimpleShutdown();

// START RULE NO. 1
   pointcut rule1(String url):
      args(url) &&
      call(static Remote Naming.lookup(String));

   before(String url):
      rule1(url)
   {
      try {
      if (!( url.split("/").length>2 ))
      { mplExit.shutdown(); }
      } catch (Exception e) {
         System.err.println(
           "Error: Policy caused an exception" +
           " - execution halted");
         mplExit.shutdown();
      }
   }

   after(String url) returning(Remote mplReturn):
      rule1(url)
   {
   try {
      lastRMIHost = url.split("/")[2];
   } catch (Exception e) {
      System.err.println(
        "Error: Policy caused an exception" +
        " - execution halted");
      mplExit.shutdown();
   }
   }

// START RULE NO. 2
   pointcut rule2(String url, int port):
      args(url, port) &&
      call(Socket.new(String, int));

   before(String url, int port):
      rule2(url, port)
   {
      try {
      if (!( lastRMIHost!=null&&
        url.equals(lastRMIHost) ))
      { mplExit.shutdown(); }
      } catch (Exception e) {
         System.err.println(
           "Error: Policy caused an exception" +
           " - execution halted");
         mplExit.shutdown();
      }
   }

   after(String url, int port)
         returning(Socket mplReturn):
      rule2(url, port)
   {
   try {
      lastRMIHost = url;
   } catch (Exception e) {
      System.err.println(
        "Error: Policy caused an exception" +
        " - execution halted");
      mplExit.shutdown();
   }
   }
}